%Procs controlat.
function sortida=Traj_circ(entrada);


%Valors inicials i parmetres
Ts=0.2;
Kgran=10*pi/180;
Kmig=5*pi/180;
Kpetit=0.3*pi/180;
ErrorMax=0.05;
Error=10;
AccelMax=1;
q_dot=[0;0;0;0;0];
nArticulacions=5;
A=eye(nArticulacions);
VarAngle=[];
accel=[];

%valor entrada
F_ext=entrada(1:6)';
vec_inicial=entrada(7:12)';
%vec_ini=vec_inicial
vec_final=entrada(13:18)';
%vec_fin=vec_final
longituds=entrada(19:23)';
massa=entrada(24:28)';

entrada=[vec_inicial',longituds'];
%Posicions Angulars
inversaVL(entrada);
%ans
Qpos=ans*pi/180;

entrada=[vec_final',longituds'];
inversaVL(entrada);
%ans
Qfinal=ans*pi/180;
errrrorrrr=Qfinal'-Qpos'

for k=1:nArticulacions
    if abs(Qpos(k)-Qfinal(k))>10*pi/180;
        VarAngle(k)=(Qfinal(k)-Qpos(k))/Kgran;
    elseif abs(Qpos(k)-Qfinal(k))<10*pi/180 && abs(Qpos(k)-Qfinal(k))>2*pi/180;
        VarAngle(k)=(Qfinal(k)-Qpos(k))/Kmig;
    elseif abs(Qpos(k)-Qfinal(k))<2*pi/180;
        VarAngle(k)=(Qfinal(k)-Qpos(k))/Kpetit;
    elseif abs(Qpos(k)-Qfinal(k))<0.05*pi/180;
        VarAngle(k)=0;
    end
    accel(k)=VarAngle(k)/(Ts^2);
    if abs(accel(k))>AccelMax;
    accel(k)=AccelMax*sign(accel(k));
    elseif abs(accel(k))<AccelMax;
    accel(k)=accel(k);
    end
end

   %Calculem l'acceleraci
    M_gran=[];
	for n=1:nArticulacions
        Q_dot=[0,0,0,0,0];
		Q_2dot=A(1:nArticulacions,n);
		Grv=[0,0,0];
        rneQLM(Qpos,Q_dot,Q_2dot,F_ext,Grv,longituds,massa);
        m=ans';
		M_gran=[M_gran m];
    end
    Q_dot=q_dot;
    Q_2dot=[0,0,0,0,0];
	Grv=[0,0,9.8];
    rneQLM2(Qpos,Q_dot,Q_2dot,F_ext,Grv,longituds,massa);
    rne2=ans;
   	b1=rne2(:,1);
    b=b1(1:nArticulacions);
    Fbase=rne2(:,2);
   
    %Calculem l'acceleraci que s'ha de donar al bra.
    q_2dot=accel;
    
    %A partir de l'acceleraci calculada  segons la distncia al punt final
    %calculem la fora que s'ha d'aplicar al bra.
    Fmotors=(q_2dot*M_gran)+b';
    q_dot=0.75*q_dot+q_2dot'*Ts;
	Qpos=Qpos+q_dot*Ts;
    entrada=[real(Qpos)',longituds'];
    %Passem la posici en qu estem a vector configuraci
    pos=directaQLgraus(entrada);
    pos=pos';
    sortida=[Fbase,pos];
end
    

    
        
            


       