%Movent els angles al mateix temps.
nArticulacions=5;
Ts=0.05;
T=50;
nIteracions=T/Ts;
ntrams=50;
Kgran=10;
Kmig=5;
Kpetit=1;
ErrorMax=0.05;
Error=10;
AccelMax=[1,1,1,0,1]*2;
q_dot=[0;0;0;0;0];
F_ext=[0;0;0;0;0;0];
A=eye(nArticulacions);
punts=[];
vconf=[];

%Posici Inicial
vec_inicial=[0.1533   -0.1827    0.3071    0.3398   -0.4049    0.9155];
%Posici Final
%vec_final=[0.1919   -0.2287   -0.1032    0.7183   -0.8561   -0.0000];
vec_final=[0.3271    0.0000    0.1419    0.6428   -0.0000    0.7660];

%Aquests rebenten
%vec_final=[0.1324   -0.1577    0.1975   -0.3429    0.4086    1.4656];
%vec_final=[0.1587   -0.1892   -0.0353   -0.0000   -0.0000   -1.5596];
%vec_final=[0.0098   -0.0117    0.3670    0.0000   -0.0000    1.5596];




%Es busca les posicions angulars inicials i finals angulars
Qini=inversa(vec_inicial);
Qfin=inversa(vec_final);

%Es passa els angles a radiants
Qini_rad=Qini*pi/180;
Qfin_rad=Qfin*pi/180;

%Calculem la posici inicial i final, l'orientaci inicial i final, i
%l'angle de la inicial i final

%Posici
pos0=vec_inicial(1:3);
posf=vec_final(1:3);

%Angle de la m
yaw0=Qini_rad(nArticulacions);
yawf=Qfin_rad(nArticulacions);

%Orientaci
orient0=(1/(exp(yaw0/pi)))*vec_inicial(4:6);
orientf=(1/(exp(yawf/pi)))*vec_final(4:6);

%Com que es vol anar del punt inicial al final en lnia recta la diferncia
%entre la posici inicial i final ens donar el vector que conecta
recta=posf-pos0;
%Idem per a la orientaci i l'angle de la m.
rorient=orientf-orient0;
ryaw=yawf-yaw0;

%Definim els intervals.
tpos=recta/ntrams;
torient=rorient/ntrams;
tyaw=ryaw/ntrams;

%Introdum el primer punt de la successi de punts que s'hauran de seguir
%per a definir una recta per a arribar al punt final.
punts=[punts Qini_rad];
vconf=[vconf vec_inicial'];
%Definim els primers punts anteriors
pos=pos0+tpos;
orient=orient0+torient;
yaw=yaw0+tyaw;

for i=1:ntrams
    vecconf=[pos,exp(yaw/pi)*(orient)];
    vconf=[vconf vecconf'];
    inversa(vecconf);
    angles=ans*pi/180;
    %Seguim emplenant la matriu de posicions intermitges
    punts=[punts angles];
    
    %Evolucionem els parmetres del vector configuraci per a qu tinguin
    %els valors del punt segent
    pos=pos+tpos;
    orient=orient+torient;
    yaw=yaw+tyaw;
    
end

%Inicialitzem el comptador de trams
vtram=2;
punt=punts(:,vtram);
   
%Trobem la fora que hi ha d'haver als motors a l'inici per a qu no baixi
%de cop

%inicialitzem la Qactual
Qact=Qini_rad;
    

for n=1:nIteracions
    %Mirem si estem suficientment aprop del punt intermig que estem
    %calculant, si ho estem passarem al segent punt intermig, sino
    %seguirem apropant-nos al punt intermig.
    
    if Error>ErrorMax
        %Calculem per a cada articulaci la variaci d'angle que hauria de
        %fer per arribar a la posici desitjada.
        for i=1:nArticulacions
            if abs(Qact(i)-Qfin_rad(i))>0.1;
                %com que la distncia respecte al punt final s superior a
                %5 graus el que es far ser posar acceleraci mxima.
                VarAngle(i)=(punt(i)-Qact(i))/Kgran;
                accel(i)=sign(VarAngle(i))*AccelMax(i);
                
            elseif abs(Qact(i)-Qfin_rad(i))<0.1 && abs(Qact(i)-Qfin_rad(i))>0.05;
                %La distncia s inferior a 5 graus per superior a 2, el
                %que es far s anar a una acceleraci la meitat de la
                %mxima
                VarAngle(i)=(punt(i)-Qact(i))/Kgran;
                accel(i)=sign(VarAngle(i))*AccelMax(i)/2;
                
            elseif abs(Qact(i)-Qfin_rad(i))<0.05;
                %Quan la distncia ja s inferior a uns 2 graus, el bra
                %s'aproximar proporcionalment a la diferncia de distncia
                %angular
                VarAngle(i)=(punt(i)-Qact(i))/Kpetit;
                accel(i)=VarAngle(i)/(Ts^2);
                
            elseif abs(Qact(i)-Qfinal(i))<0.05;
                VarAngle(i)=0;
            end
            
                      
            %Condicional per limitar l'acceleraci mxima de cada
            %articulaci per adequar-la a la real.            
            if abs(accel(i))>AccelMax(i);
               accel(i)=sign(accel(i))*AccelMax(i);
                
            else abs(accel(i))<AccelMax(i);
                accel(i)=accel(i);
            end
            
        %Finalitzem el per que hem fet servir per a calcular cada
        %articulaci
        end
        
        %Definim l'error que hi ha entre la nostra posici i el punt com a
        %0, d'aquesta manera podem calcular l'error de nou
        
        Error=0;
        
        %Calculem l'error que tenim del punt actual respecte al punt
        %intermig desitjat
        
        for i=1:nArticulacions
            Errori=abs(norm(Qact(i))-norm(punt(i)));
            Error=Error+Errori;
        end
        
        %Com que hem hagut de fer un avan de la posici anterior aqu
        %estem obligats a pintar la nova posici
        
        %La matriu de massa degut a la posici que tenim ser la definida
        %segons la matriu M_gran
        
        M_gran=[];
        
        %Fent l'acceleraci igual a 1 a cada articulaci es trobar la
        %disposici de masses que s'obtenen amb la posici actual
        for n=1:nArticulacions
            Q_dot=[0,0,0,0,0];
    		Q_2dot=A(1:nArticulacions,n);
        	Grv=[0,0,0];
            F_extm=[0;0;0;0;0;0];
    		RNE(Qact,Q_dot,Q_2dot,F_extm,Grv);
            m=ans';
            M_gran=[M_gran m];
        end
        
        %Es defineixeim els valors reals de velocitat per a calcular les 
        %degudes a aquestes moviments a cada articulaci
        Q_dot=q_dot;
        Q_dot
        Q_2dot=[0,0,0,0,0];
        Grv=[0,0,9.8];
        RNE2(Qpos,Q_dot,Q_2dot,F_ext,Grv);
        rne2=ans;
	
        
        %Forces degudes a la dinmica
    	b1=rne2(:,1)
        b=b1(1:nArticulacions);
        Fbase=rne2(:,2);
                
        %Calculem l'acceleraci que s'ha de donar al bra.
        q_2dot=accel;
        
        %A partir de l'acceleraci calculada  segons la distncia al punt final
        %calculem la fora que s'ha d'aplicar al bra.
        Fmotors=(q_2dot*M_gran)+b';
        q_dot=0.75*q_dot+q_2dot'*Ts;
    	Qact=Qact+q_dot*Ts;
        
        %Dibuixem com queda la disposici del bra
        DibuixaArmRad(Qact)
        
            
    %la segona entrada del condicional ve referida a si l'error s inferior
    %al determinat, si ho s llavors s'haur de passar al punt intermig
    %segent.
    elseif Error<ErrorMax && vtram<(ntrams+1);
        vtram=vtram+1;
        punt=punts(:,vtram);
        Error=100;
    else Error<ErrorMax && vtram>ntrams;
        M_gran=[];
        
        %Fent l'acceleraci igual a 1 a cada articulaci es trobar la
        %disposici de masses que s'obtenen amb la posici actual
        for n=1:nArticulacions
            Q_dot=[0,0,0,0,0];
    		Q_2dot=A(1:nArticulacions,n);
        	Grv=[0,0,0];
            F_extm=[0;0;0;0;0;0];
    		RNE(Qact,Q_dot,Q_2dot,F_extm,Grv);
            m=ans';
            M_gran=[M_gran m];
        end
        
        %Es defineixeim els valors reals de velocitat per a calcular les 
        %degudes a aquestes moviments a cada articulaci
        Q_dot=q_dot;
        Q_2dot=[0,0,0,0,0];
        Grv=[0,0,9.8];
        RNE(Qact,Q_dot,Q_2dot,F_ext,Grv);
        
        %Forces degudes a la dinmica
    	b=ans;
        
        %Calculem l'acceleraci que s'ha de donar al bra.
        q_2dot=[0,0,0,0,0];
        
        %A partir de l'acceleraci calculada  segons la distncia al punt final
        %calculem la fora que s'ha d'aplicar al bra.
       
        Fmotors=(q_2dot*M_gran)+b;
        q_dot=0.75*q_dot+q_2dot'*Ts;
    	Qact=Qact+q_dot*Ts;
        DibuixaArmRad(Qact)
        pause()
        
    end
    pause()
end