function R = rotacions(q)

%Es calculen els cosinus de tots els angles
c1=cos(q(1));
c2=cos(q(2));
c3=cos(q(3));
c4=cos(q(4));
c5=cos(q(5));

%Es calculen els sinus de tots els angles
s1=sin(q(1));
s2=sin(q(2));
s3=sin(q(3));
s4=sin(q(4));
s5=sin(q(5));

%Es defineix la matriu de rotaci i es transposa
R{1}=[c1 0 s1;
    s1 0 -c1;
    0 1 0];
R{1} = (R{1})';

%Es fa exactament el mateix que en la matriu anterior, per per la resta articulacions
R{2}=[c2 -s2 0;
    s2 c2 0;
    0 0 1];
R{2} = (R{2})';


R{3}=[c3 -s3 0;
    s3 c3 0;
    0 0 1];
R{3} = (R{3})';

R{4}=[c4 0 s4;
    s4 0 -c4;
    0 1 0];
R{4} = (R{4})';

R{5}=[c5 -s5 0;
    s5 c5 0;
    0 0 1];
R{5} = (R{5})';

