%Procs controlat.
function sortida=manipulador(F_ext,vec_inicial,vec_final);
%Valors inicials i parmetres
nArticulacions=5;
Ts=0.05;
T=50;
nIteracions=T/Ts;
Kgran=10*pi/180;
Kmig=5*pi/180;
Kpetit=1*pi/180;
ErrorMax=0.05;
Error=10;
AccelMax=1;
q_dot=[0;0;0;0;0];
%F_ext=[0;0;5;0;10;0];
A=eye(nArticulacions);
VarAngle=[];
accel=[];


%Posici Inicial
%vec_inicial=[0.1533   -0.1827    0.3071    0.3398   -0.4049    0.9155];
%Posici Final
%vec_final=[0.1919   -0.2287   -0.1032    0.7183   -0.8561   -0.0000];
%vec_final=[0.3271    0.0000    0.1419    0.6428   -0.0000    0.7660];


%Posicions Angulars
inversa(vec_inicial);
Qpos=ans*pi/180;
inversa(vec_final);
Qfinal=ans*pi/180;

for k=1:nArticulacions
    if abs(Qpos(k)-Qfinal(k))>10*pi/180;
        VarAngle(k)=(Qfinal(k)-Qpos(k))/Kgran;
    elseif abs(Qpos(k)-Qfinal(k))<10*pi/180 && abs(Qpos(k)-Qfinal(k))>2*pi/180;
        VarAngle(k)=(Qfinal(k)-Qpos(k))/Kmig;
    elseif abs(Qpos(k)-Qfinal(k))<2*pi/180;
        VarAngle(k)=(Qfinal(k)-Qpos(k))/Kpetit;
    elseif abs(Qpos(k)-Qfinal(k))<0.1*pi/180;
        VarAngle(k)=0;
    end
    accel(k)=VarAngle(k)/(Ts^2);
    if abs(accel(k))>AccelMax;
    accel(k)=AccelMax*sign(accel(k));
    elseif abs(accel(k))<AccelMax;
    accel(k)=accel(k);
    end
end
    
   %Calculem l'acceleraci
    M_gran=[];
	for n=1:nArticulacions
        Q_dot=[0,0,0,0,0];
		Q_2dot=A(1:nArticulacions,n);
		Grv=[0,0,0];
		rneQLM(Qpos,Q_dot,Q_2dot,F_ext,Grv);
        m=ans';
		M_gran=[M_gran m];
    end
    Q_dot=q_dot;
    Q_2dot=[0,0,0,0,0];
	Grv=[0,0,-9.81];
    rneQLM2(Qpos,Q_dot,Q_2dot,F_ext,Grv);
    rne2=ans;
	b1=rne2(:,1);
    b=b1(1:nArticulacions);
    Fbase=rne2(:,2);
   
    %Calculem l'acceleraci que s'ha de donar al bra.
    q_2dot=accel;
    
    %A partir de l'acceleraci calculada  segons la distncia al punt final
    %calculem la fora que s'ha d'aplicar al bra.
    size((q_2dot*M_gran))
    Fmotors=(q_2dot*M_gran)+b';
    q_dot=0.75*q_dot+q_2dot'*Ts;
	Qpos=Qpos+q_dot*Ts;
    
    %Passem la posici en qu estem a vector configuraci
    pos=directaQ(Qpos);
    sortida=[Fbase,pos];
end
    

    
        
            


       