%Procs controlat.
function sortida=Traj_circ(entrada);


%Valors inicials i parmetres
Ts=0.2;
Kgran=10*pi/180;
Kmig=5*pi/180;
Kpetit=0.3*pi/180;
ErrorMax=0.05;
Error=10;
AccelMax=1;
q_dot=[0;0;0;0;0];
nArticulacions=5;

KVel=[2,2,15,2,0.5];
VMax=[0.1,0.1,0.1,0.1,0.1];

A=eye(nArticulacions);
VarAngle=[];
vel=[];
vcons=[];
FMot_=[];

%valor entrada
F_ext=entrada(1:6)';
vec_inicial=entrada(7:12)';
%vec_ini=vec_inicial
vec_final=entrada(13:18)';
%vec_fin=vec_final
longituds=entrada(19:23)';
massa=entrada(24:28)';
Vanterior=entrada(29:33)';
EanteriorBra=entrada(34:38)';

entrada=[vec_inicial',longituds'];
%Posicions Angulars
inversaVL(entrada);
%ans
Qpos=ans*pi/180;

entrada=[vec_final',longituds'];
inversaVL(entrada);
%ans
Qfinal=ans*pi/180;

%Parmetres de configuraci del PID del bra mecnic
Kp_pos=[0,      0,      0,      0,      0];
Ki_pos=[0,      0,      0,      0,      0];
Kd_pos=[0,      0,      0,      0,      0];
%Parmetres del PID ERROR NEGATIU
Kp_neg=[0,      0,      0,      0,      0];
Ki_neg=[0,      0,      0,      0,      0];
Kd_neg=[0,      0,      0,      0,      0];


ErrorAngl=Qfinal'-Qpos';
Qfinal
Qpos
ErrorAngl
%Calculem l'error de posici per a cada una de les articulacions
%Es Calcula la velocitat que hauria de tenir en funci de la distncia,
for i=1:5
    veli=KVel(i)*ErrorAngl(i);
    vel=[vel veli];
end


for i=1:5
    if (abs(vel(i)))>VMax(i)
        vel(i)=sign(vel(i))*VMax(i);
    elseif (abs(vel(i)))<VMax(i)
        vel(i)=vel(i);
    end
    vcons=[vcons vel(i)];
end
%vcons
vcons=vcons';

Error=vcons-Vanterior;
Eintegral=EanteriorBra+Error*Ts;
Ederivatiu=(Error-EanteriorBra)/Ts;


for i=1:5
    if Error(i)<=0;
        FNi=Kp_neg(i)*Error(i)+Kd_neg(i)*Ederivatiu(i)+Ki_neg(i)*Eintegral(i);
    elseif Error(i)>0;
        FNi=Kp_pos(i)*Error(i)+Kd_pos(i)*Ederivatiu(i)+Ki_pos(i)*Eintegral(i);
    end
    FMot_=[FMot_ FNi];
end
FMot_
Fmotors=FMot_';

   %Calculem l'acceleraci
    M_gran=[];
	for n=1:nArticulacions
        Q_dot=[0,0,0,0,0];
		Q_2dot=A(1:nArticulacions,n);
		Grv=[0,0,0];
        rneQLM(Qpos,Q_dot,Q_2dot,F_ext,Grv,longituds,massa);
        m=ans';
		M_gran=[M_gran m];
    end
    
    Q_dot=q_dot;
    Q_2dot=[0,0,0,0,0];
	Grv=[0,0,9.8];
    rneQLM2(Qpos,Q_dot,Q_2dot,F_ext,Grv,longituds,massa);
    rne2=ans;
   	b1=rne2(:,1);
    b=b1(1:nArticulacions);
    Fbase=rne2(:,2);
    
   
    %A partir de l'acceleraci calculada  segons la distncia al punt final
    %calculem la fora que s'ha d'aplicar al bra.
    M_gran
    b
    q_2dot=M_gran^(-1)*(Fmotors-b);
     q_dot
    q_2dot
    q_dot=0.75*q_dot+q_2dot*Ts;
	Qpos=Qpos+q_dot*Ts;
    entrada=[real(Qpos)',longituds'];
    %Passem la posici en qu estem a vector configuraci
    pos=directaQLgraus(entrada);
    pos=pos';
    velBra=q_dot';
    EanteriorBra=Error';
    sortida=[Fbase',pos',velBra,EanteriorBra];
    sortida
end
    

    
        
            


       