%function resposta=inversa(px,py,pz,w2x,w2y,w2z)
function resposta=InversaRNE(posicio)
px=posicio(1);
py=posicio(2);
pz=posicio(3);
w2x=posicio(4);
w2y=posicio(5);
w2z=posicio(6);

%parmetres del Robot
Adist=[0.05,0.2,0.1,0,0];
Ddist=[0.05,0,0,0,0.02];

%Aplicant equacions ja trobades trobem les qi a partir del vector d'input.

q1=atan2(py,px);
%trigonometria de q1
S1=sin(q1);
C1=cos(q1);

%Clcul de q234
%q234=atan2((w2y/S1+w2x/C1),-2*w2z);
q234=atan2(C1*w2x+S1*w2y,-w2z);
%trigonometria de q234
S234=sin(q234);
C234=cos(q234);

%b1 i b2
b1=C1*px+S1*py-Ddist(5)*S234-Adist(1);
b2=pz+Ddist(5)*C234-Ddist(1);

%Clcul de q3
aa0=((b1)^2+(b2)^2-(Adist(3))^2-(Adist(2))^2);
bb0=(2*Adist(3)*Adist(2));
q3=acos(aa0/bb0);

%trigonometria q3
S3=sin(q3);
C3=(b1^2+b2^2-Adist(3)^2-Adist(2)^2)/(2*Adist(3)*Adist(2));

%Clcul de q2
%q2=atan2((Adist(3)*C3+Adist(2))*b2-(Adist(3)*S3)*b1,(Adist(3)*C3+Adist(2))*b1+(Adist(3)*S3)*b2);
%trigonometria q2
%S2=sin(q2);
%C2=cos(q2);

%Clcul de q4
q4=90*pi/180;
S4=sin(q4);
C4=cos(q4);

q2=q234-q3-q4;
S2=sin(q2);
C2=cos(q2);

%Clcul de q5
q5=pi*log(sqrt(((w2x)^2+(w2y)^2+(w2z)^2)));
%Les q amb graus
Q=180/pi*[q1,q2,q3,q4,q5];
resposta=[Q'];